<?php
namespace App\Controller;

use App\Controller\AppController;

/**
 * Histories Controller
 *
 * @property \App\Model\Table\HistoriesTable $Histories
 */
class HistoriesController extends AppController
{

	/**
	 * 日次レポート
	 *
	 * @return void
	 */
	public function daily()
	{
		global	$event_id_moving;
		global	$event_id_temperature;
		global	$event_id_humidity;
		
		$this->set('title','日毎レポート');
		if ($this->request->is('post')) {
			$now = date_create(		// フォームで指定された集計日を取得
							$this->request->data['集計日']['year'] . '-' . 
							$this->request->data['集計日']['month'] . '-' .
							$this->request->data['集計日']['day'] );
		} else {
			$now = date_create();		// 現在時刻を取得
			$now->setTime(23,59,59);	// 今日の最終時刻(秒単位)…「1日前」の判断に使用
		}
		$now->setTime(23,59,59);	// 今日の最終時刻(秒単位)…「1日前」の判断に使用
		
		//-- eventsモデルをロードし体動のIDを取得 --
		// 体動
		$this->loadModel('events');
		$events_query = $this->events->find();
		$events_query->select(['id','name']);
		$events_query->where(['name'=>'moving']);
		$result_events =$events_query->find('all')->toArray();
		if( count($result_events) != 0 )  {
			$event_id_moving = $result_events[0]['id'];
		} else {
			$event_id_moving = 0;
		}
		// 温度
		$events_query = $this->events->find('all');
		$events_query->where(['name'=>'temperature']);
		$result_events =$events_query->find('all')->toArray();
		if( count($result_events) != 0 )  {
			$event_id_temperature = $result_events[0]['id'];
		} else {
			$event_id_temperature = 0;
		}
		// 湿度
		$events_query = $this->events->find('all');
		$events_query->where(['name'=>'humidity']);
		$result_events =$events_query->find('all')->toArray();
		if( count($result_events) != 0 )  {
			$event_id_humidity = $result_events[0]['id'];
		} else {
			$event_id_humidity = 0;
		}
		
		// instrumentsモデルをロードし全装置を抽出
		$this->loadModel('instruments');
		$instruments_query = $this->instruments->find('all');
		$instruments_count = $this->instruments->find('all')->count();

		// 空の配列を作る(行=n時台,列=装置)
		$row_moving = array_pad(array('時台'), $instruments_count+1, 0);
		$row_temp_humid = array_pad(array('時台'), $instruments_count*2+1, 0);
		$graph_data_moving = array_pad(array(), 25, $row_moving);
		$graph_data_temperature = array_pad(array(), 25, $row_moving);
		$graph_data_temp_humid = array_pad(array(), 25, $row_temp_humid);
		for( $i=0; $i<24; $i++)  {
			$graph_data_moving[$i+1][0] = "{$i}時台";
			$graph_data_temperature[$i+1][0] = "{$i}時台";
			$graph_data_temp_humid[$i+1][0] = "{$i}時台";
		}
		// グラフデータを作成
		$stored_col = 0;	// 集計したデータを置く列を表す(1=1つ目の装置,2=2つ目の装置...)
		foreach( $instruments_query as $instrument)  {
			$stored_col++;
			$graph_data_moving[0][$stored_col] = $instrument->room;
			$graph_data_temperature[0][$stored_col] = $instrument->room;
			$graph_data_temp_humid[0][$stored_col] = $instrument->room.'の温度';
			$graph_data_temp_humid[0][$instruments_count+$stored_col] = $instrument->room.'の湿度';
			// クエリーオブジェクトを作成				
			$histories_query = $this->Histories->find();
			$histories_query->select(['_sum' => $histories_query->func()->sum('value')]);
			// 15分毎
			//$histories_query->select(['_time' => 'FROM_UNIXTIME(TRUNCATE(UNIX_TIMESTAMP(`date`)/900,0)*900)']);
			//$histories_query->where('date','BETWEEN DATE_SUB(curdate(),interval 7 day) and DATE_ADD(curdate(),interval 0 day)');
			//$histories_query->group('TRUNCATE(UNIX_TIMESTAMP(`date`)/900,0)');
			// 1時間毎
			$histories_query->select(['_time' => 'FROM_UNIXTIME(TRUNCATE(UNIX_TIMESTAMP(`date`)/3600,0)*3600)']);
			$histories_query->where('date BETWEEN DATE_SUB(\'' . $now->format('Y-m-d') . '\',interval 0 day) and DATE_ADD(\'' . $now->format('Y-m-d') . '\',interval 1 day)');
			$histories_query->andWhere('instrument_id = ' . $instrument->id);
			$histories_query->group('TRUNCATE(UNIX_TIMESTAMP(`date`)/3600,0)');
			// 1日毎
			//$histories_query->select(['_time' => 'DATE_FORMAT(`date`,\'%Y-%m-%d\')']);
			//$histories_query->where('date BETWEEN DATE_SUB(curdate(),interval 7 day) and DATE_ADD(curdate(),interval 0 day)');
			//$histories_query->group('DATE_FORMAT(`date`,\'%Y%m%d\')');
			$histories_query->matching('Events',function($q)  {
				global $event_id_moving;
				return $q->where(['Events.id' => $event_id_moving]);
			});
					
			// 配列へ格納
			foreach($histories_query->all() as $graph)  {
				$diff = date_diff(date_create($graph["_time"]), $now);
				$cur = date_parse($graph["_time"]);
				$graph_data_moving[$cur["hour"]+1][$stored_col] = (int)$graph["_sum"];
			}

			// 温度データの処理
			$histories_query->select(['_avg' => $histories_query->func()->avg('value')]);
			// 15分毎
			//$histories_query->select(['_time' => 'FROM_UNIXTIME(TRUNCATE(UNIX_TIMESTAMP(`date`)/900,0)*900)']);
			//$histories_query->where('date','BETWEEN DATE_SUB(curdate(),interval 7 day) and DATE_ADD(curdate(),interval 0 day)');
			//$histories_query->group('TRUNCATE(UNIX_TIMESTAMP(`date`)/900,0)');
			// 1時間毎
			$histories_query->select(['_time' => 'FROM_UNIXTIME(TRUNCATE(UNIX_TIMESTAMP(`date`)/3600,0)*3600)']);
			$histories_query->where('date BETWEEN DATE_SUB(\'' . $now->format('Y-m-d') . '\',interval 0 day) and DATE_ADD(\'' . $now->format('Y-m-d') . '\',interval 1 day)');
			$histories_query->andWhere('instrument_id = ' . $instrument->id);
			$histories_query->group('TRUNCATE(UNIX_TIMESTAMP(`date`)/3600,0)');
			// 1日毎
			//$histories_query->select(['_time' => 'DATE_FORMAT(`date`,\'%Y-%m-%d\')']);
			//$histories_query->where('date BETWEEN DATE_SUB(curdate(),interval 7 day) and DATE_ADD(curdate(),interval 0 day)');
			//$histories_query->group('DATE_FORMAT(`date`,\'%Y%m%d\')');
			$histories_query->matching('Events',function($q)  {
				global $event_id_temperature;
				return $q->where(['Events.id' => $event_id_temperature]);
			});
					
			// 配列へ格納
			foreach($histories_query->all() as $graph)  {
				$diff = date_diff(date_create($graph["_time"]), $now);
				$cur = date_parse($graph["_time"]);
				$graph_data_temperature[$cur["hour"]+1][$stored_col] = (float)$graph["_avg"];
				$graph_data_temp_humid[$cur["hour"]+1][$stored_col] = (float)$graph["_avg"];
			}

			// 湿度データの処理
			$histories_query->select(['_avg' => $histories_query->func()->avg('value')]);
			// 15分毎
			//$histories_query->select(['_time' => 'FROM_UNIXTIME(TRUNCATE(UNIX_TIMESTAMP(`date`)/900,0)*900)']);
			//$histories_query->where('date','BETWEEN DATE_SUB(curdate(),interval 7 day) and DATE_ADD(curdate(),interval 0 day)');
			//$histories_query->group('TRUNCATE(UNIX_TIMESTAMP(`date`)/900,0)');
			// 1時間毎
			$histories_query->select(['_time' => 'FROM_UNIXTIME(TRUNCATE(UNIX_TIMESTAMP(`date`)/3600,0)*3600)']);
			$histories_query->where('date BETWEEN DATE_SUB(\'' . $now->format('Y-m-d') . '\',interval 0 day) and DATE_ADD(\'' . $now->format('Y-m-d') . '\',interval 1 day)');
			$histories_query->andWhere('instrument_id = ' . $instrument->id);
			$histories_query->group('TRUNCATE(UNIX_TIMESTAMP(`date`)/3600,0)');
			// 1日毎
			//$histories_query->select(['_time' => 'DATE_FORMAT(`date`,\'%Y-%m-%d\')']);
			//$histories_query->where('date BETWEEN DATE_SUB(curdate(),interval 7 day) and DATE_ADD(curdate(),interval 0 day)');
			//$histories_query->group('DATE_FORMAT(`date`,\'%Y%m%d\')');
			$histories_query->matching('Events',function($q)  {
				global $event_id_humidity;
				return $q->where(['Events.id' => $event_id_humidity]);
			});
					
			// 配列へ格納
			foreach($histories_query->all() as $graph)  {
				$diff = date_diff(date_create($graph["_time"]), $now);
				$cur = date_parse($graph["_time"]);
				$graph_data_temp_humid[$cur["hour"]+1][$instruments_count+$stored_col] = (float)$graph["_avg"];
			}
		}
		$this->autoRender = true;
		$this->set('graph_data_moving', $graph_data_moving);
		$this->set('graph_data_temperature', $graph_data_temperature);
		$this->set('graph_data_temp_humid', $graph_data_temp_humid);
	}
	
    /**
     * 週次レポート
     *
     * @return void
     */
    public function weekly()
    {
    	global		$event_id;
		if ($this->request->is('post')) {
			$now = date_create(		// フォームで指定された集計日を取得
							$this->request->data['集計日']['year'] . '-' . 
							$this->request->data['集計日']['month'] . '-' .
							$this->request->data['集計日']['day'] );
		} else {
			$now = date_create();		// 現在時刻を取得
			$now->setTime(23,59,59);	// 今日の最終時刻(秒単位)…「1日前」の判断に使用
		}
		$now->setTime(23,59,59);	// 今日の最終時刻(秒単位)…「1日前」の判断に使用

    	// eventsモデルをロードし体動のIDを取得
		$this->loadModel('events');
		$events_query = $this->events->find();
		$events_query->select(['id','name']);
		$events_query->where(['name'=>'moving']);
		$result_events =$events_query->find('all')->toArray();
		if( count($result_events) != 0 )  {
			$event_id = $result_events[0]['id'];
		} else {
			$event_id = 0;
		}
		
		// クエリーオブジェクトを作成
    	$histories_query = $this->Histories->find();
    	$histories_query->select(['_sum' => $histories_query->func()->sum('value')]);
    	// 15分毎
    	//$histories_query->select(['_time' => 'FROM_UNIXTIME(TRUNCATE(UNIX_TIMESTAMP(`date`)/900,0)*900)']);
		//$histories_query->where('date BETWEEN DATE_SUB(\'' . $now->format('Y-m-d') . '\',interval 6 day) and DATE_ADD(\'' . $now->format('Y-m-d') . '\',interval 1 day)');
    	//$histories_query->group('TRUNCATE(UNIX_TIMESTAMP(`date`)/900,0)');
    	// 1時間毎
    	$histories_query->select(['_time' => 'FROM_UNIXTIME(TRUNCATE(UNIX_TIMESTAMP(`date`)/3600,0)*3600)']);
		$histories_query->where('date BETWEEN DATE_SUB(\'' . $now->format('Y-m-d') . '\',interval 6 day) and DATE_ADD(\'' . $now->format('Y-m-d') . '\',interval 1 day)');
    	$histories_query->group('TRUNCATE(UNIX_TIMESTAMP(`date`)/3600,0)');
    	// 1日毎
    	//$histories_query->select(['_time' => 'DATE_FORMAT(`date`,\'%Y-%m-%d\')']);
		//$histories_query->where('date BETWEEN DATE_SUB(\'' . $now->format('Y-m-d') . '\',interval 6 day) and DATE_ADD(\'' . $now->format('Y-m-d') . '\',interval 1 day)');
    	//$histories_query->group('DATE_FORMAT(`date`,\'%Y%m%d\')');
    	$histories_query->matching('Events',function($q)  {
    		global		$event_id;
    		return $q->where(['Events.id' => $event_id]);
    	});
    		 
    	// 空の配列を作る
    	$graph_data[0] =[ "時刻","6日前","5日前","4日前","3日前","2日前","1日前",$now->format('Y年m月d日')];
    	for( $i=0; $i<24; $i++)  {
    		$graph_data[$i+1] = array( "$i" . "時台", 0, 0, 0, 0, 0, 0, 0);
    	}
    	// データを格納
    	foreach($histories_query->all() as $history)  {
    		$diff = date_diff(date_create($history["_time"]), $now);
			$cur = date_parse($history["_time"]);
			$graph_data[$cur["hour"]+1][7-$diff->d] = (int)$history["_sum"];
    		//echo  date("Y M D H i s") . " " . $history["_time"] . "  " . $diff->d . " " . $cur["hour"] . " " .$history["_sum"] . "<br>\r\n";
    	}
    	$this->autoRender = true;
    	$this->set('graph_data', $graph_data);
    }

    /**
     * Index method
     *
     * @return void
     */
    public function index()
    {
        $this->paginate = [
            'contain' => ['Instruments', 'Events']
        ];
        $this->set('histories', $this->paginate($this->Histories));
        $this->set('_serialize', ['histories']);
    }

    /**
     * Add method
     *
     * @return void Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $history = $this->Histories->newEntity();
        if ($this->request->is('post')) {
            $history = $this->Histories->patchEntity($history, $this->request->data);
            if ($this->Histories->save($history)) {
                $this->Flash->success(__('The history has been saved.'));
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error(__('The history could not be saved. Please, try again.'));
            }
        }
        $instruments = $this->Histories->Instruments->find('list', ['limit' => 200]);
        $events = $this->Histories->Events->find('list', ['limit' => 200]);
        $this->set(compact('history', 'instruments', 'events'));
        $this->set('_serialize', ['history']);
    }

    /**
     * Edit method
     *
     * @param string|null $id History id.
     * @return void Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $history = $this->Histories->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $history = $this->Histories->patchEntity($history, $this->request->data);
            if ($this->Histories->save($history)) {
                $this->Flash->success(__('The history has been saved.'));
                return $this->redirect(['action' => 'index']);
            } else {
                $this->Flash->error(__('The history could not be saved. Please, try again.'));
            }
        }
        $instruments = $this->Histories->Instruments->find('list', ['limit' => 200]);
        $events = $this->Histories->Events->find('list', ['limit' => 200]);
        $this->set(compact('history', 'instruments', 'events'));
        $this->set('_serialize', ['history']);
    }

    /**
     * Delete method
     *
     * @param string|null $id History id.
     * @return \Cake\Network\Response|null Redirects to index.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $history = $this->Histories->get($id);
        if ($this->Histories->delete($history)) {
            $this->Flash->success(__('The history has been deleted.'));
        } else {
            $this->Flash->error(__('The history could not be deleted. Please, try again.'));
        }
        return $this->redirect(['action' => 'index']);
    }
}
