<?php
namespace App\Model\Table;

use App\Model\Entity\Instrument;
use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Instruments Model
 *
 * @property \Cake\ORM\Association\HasMany $Histories
 */
class InstrumentsTable extends Table
{

    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);

        $this->table('instruments');
        $this->displayField('id');
        $this->primaryKey('id');

        $this->hasMany('Histories', [
            'foreignKey' => 'instrument_id'
        ]);
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator)
    {
        $validator
            ->add('id', 'valid', ['rule' => 'numeric'])
            ->allowEmpty('id', 'create');

        $validator
            ->requirePresence('room', 'create')
            ->notEmpty('room');

        $validator
            ->requirePresence('place', 'create')
            ->notEmpty('place');

        $validator
            ->requirePresence('ip_address', 'create')
            ->notEmpty('ip_address');

        return $validator;
    }
}
