<nav class="large-3 medium-4 columns" id="actions-sidebar">
    <ul class="side-nav">
        <li class="heading"><?= __('集計') ?></li>
        <li><?= $this->Html->link(__('週間レポート'), ['action' => 'weekly']) ?></li>
        <li class="heading"><?= __('メンテナンス') ?></li>
        <li><?= $this->Html->link(__('履歴追加'), ['action' => 'add']) ?></li>
        <li><?= $this->Html->link(__('機器一覧'), ['controller' => 'Instruments', 'action' => 'index']) ?></li>
        <li><?= $this->Html->link(__('機器追加'), ['controller' => 'Instruments', 'action' => 'add']) ?></li>
        <li><?= $this->Html->link(__('イベント一覧'), ['controller' => 'Events', 'action' => 'index']) ?></li>
        <li><?= $this->Html->link(__('イベント追加'), ['controller' => 'Events', 'action' => 'add']) ?></li>
    </ul>
</nav>
<div class="histories index large-9 medium-8 columns content">
    <!-- タイトル -->
    <h3><?= __('日次レポート') ?></h3>
	
    <!-- 集計日 -->
	<?= $this->Form->create('Post'); ?>
	<div class="base_date" style='float:left;'>
		<?= $this->Form->input('集計日',array('type'=> 'date'));  ?>
	</div>
	<div class="base_date_update">
		<?= $this->Form->postButton('更新', '/histories/daily');  ?>
		<?= $this->Form->end(); ?>
	</div>

    <!-- 体動グラフ -->
    <div id="chart_div_moving"></div>
    <!-- 温度グラフ -->
    <div id="chart_div_humidity"></div>

	<!-- グラフ描画スクリプト -->           
    <script type="text/javascript">
    	google.charts.load( 'current', {packages:['corechart','bar','line']});
	    google.charts.setOnLoadCallback(drawChart);
	    function drawChart() {
			var array_tmp = <?php echo json_encode($graph_data_moving, JSON_HEX_TAG | JSON_HEX_AMP | JSON_HEX_APOS | JSON_HEX_QUOT); ?>;
	    	var array_data = google.visualization.arrayToDataTable(array_tmp);
			//console.log(array_tmp);
		    var options = {
	  	    	isStacked: true,
	  	    	width: 800,
	  	    	height: 600,
		        bars: 'horizontal',
		        title: '活動',
				titleTextStyle: { color: '#be140b', fontSize: 20, },
		        hAxis: {
			         title: '検出時間(s)'
	            },
				chartArea:  {
					width: '70%',
					height: '80%',
					left: '10%',
				},
				legend:  {
					position: 'top',
				},
		    };
	      	var chart = new google.visualization.BarChart(document.getElementById('chart_div_moving'));
	      	chart.draw(array_data, options);

	      	// 湿度グラフ
			var array_tmp = <?php echo json_encode($graph_data_temp_humid, JSON_HEX_TAG | JSON_HEX_AMP | JSON_HEX_APOS | JSON_HEX_QUOT); ?>;
	    	var array_data = google.visualization.arrayToDataTable(array_tmp);
	        var materialOptions = {
				chart: {
					title: '温度と湿度',
					titleTextStyle: { color: '#be140b', fontSize: 20, },
				},
				width: 800,
				height: 500,
				series: {
					0: {axis: 'Temps'},
					1: {axis: 'Temps'},
					2: {axis: 'Humidity', lineWidth:5, lineDashStyle:[5,5,5]},
					3: {axis: 'Humidity', lineWidth:5, lineDashStyle:[5,5,5]},
				},
				axes: {
					y: {
						Temps: {label: '温度 (℃)'},
						Humidity: {label: '湿度（％）'}
					}
				},
				chartArea:  {
					width: '50%',
					height: '80%',
				},
				legend:  {
					position: 'top',
				},
	        };
	        var classicOptions = {
				title: '温度と湿度',
				titleTextStyle: { color: '#be140b', fontSize: 20, },
	    		width: 800,
	    		height: 600,
				chartArea:  {
					width: '70%',
					height: '70%',
					left: '10%',
				},
				series: {
					0: { targetAxisIndex: 0, color: 'blue', },
					1: { targetAxisIndex: 0, color: 'red',},
					2: { targetAxisIndex: 1, color: 'blue', lineWidth: 5, lineDashStyle:[5,5,5], },
					3: { targetAxisIndex: 1, color: 'red',  lineWidth: 5, lineDashStyle:[5,5,5], },
				},
				vAxes: {
					0:	{ title: '温度 (℃）',},
					1:	{ title: '湿度（％）',},
				},
				legend:  {
					position: 'top',
				},
	        };

	        var chartDiv = document.getElementById('chart_div_humidity');
	        // materialがベータ版のためclassicChartを使う
			//var materialChart = new google.charts.Line(chartDiv);
			//materialChart.draw(array_data, materialOptions);
			var classicChart = new google.visualization.LineChart(chartDiv);
			classicChart.draw(array_data, classicOptions);
		}

	    
    </script>
</div>
